class Sphere {
  float radian1;
  float radian2;
  float radianSpeed1;
  float radianSpeed2;
  float rradius, sspeed;
  float sspacer;
  color cc;

  Sphere(float radius, float speed, float spacer, color c) {   
    cc=c;
    rradius = radius;
    sspeed = speed;
    sspacer = spacer;
    radian1 = random(PI * 2);
    radian2 = random(PI * 2);
    radianSpeed1 = random(1) < 0.5 ? SPHERE_RADIAN_SPEED : -1.0 * SPHERE_RADIAN_SPEED;
  }

  void draw() {
    fill(cc, 100);
    stroke(255, 10);   
    
    pushMatrix();
    //translate(width/2, height/2, 100);
    //translate(ORBITAL_RADIOUS * sin(radian1) * cos(radian2), ORBITAL_RADIOUS * sin(radian1) * sin(radian2), ORBITAL_RADIOUS * cos(radian1));


    //move to center
    translate(width/2, height/2, sspacer);

    //rotate it
    rotate((frameCount*0.01*(sspeed*0.05))*TWO_PI/360);
    //center of what its rotating around
    //translate((rradius/4)*(sspacer),(rradius/4)*(sspacer));
    //println(sspacer);
    translate(width/2+sspacer, height/2+sspacer);
    sphere(rradius);
    popMatrix();
  }

  void update() {
    radian1 += radianSpeed1;
    radian2 += radianSpeed2;
    if (radian1 < 0) {
      radian1 += PI * 2;
    } else if (radian1 >= PI * 2) {
      radian1 -= PI * 2;
    }
    if (radian2 < 0) {
      radian2 += PI * 2;
    } else if (radian2 >= PI * 2) {
      radian2 -= PI * 2;
    }
  }
}